dofile("sys/lua/Minimap/includes/stream.lua");
function io.save_bitmap(file, data)
	local stream = io.open(file, "wb");

	local rowSize, pixelArraySize, fileSize, padding;
	rowSize = math.ceil((32*#data)/32) * 4;
	pixelArraySize = rowSize * #data[#data];
	fileSize = 54 + pixelArraySize;

	-- File header
	stream:write("BM");
	io.write_int(stream, fileSize);
	io.write_short(stream, 0);
	io.write_short(stream, 0);
	io.write_int(stream, 54);

	-- Bitmap header
	io.write_int(stream, 40);
	io.write_int(stream, #data);
	io.write_int(stream, #data[#data]);
	io.write_short(stream, 1);
	io.write_short(stream, 32);
	io.write_int(stream, 0);
	io.write_int(stream, pixelArraySize);
	io.write_int(stream, 2385);
	io.write_int(stream, 2385);
	io.write_int(stream, 0);
	io.write_int(stream, 0);

	-- Pixel array
	for y = #data[#data], 1, -1 do
		for x = #data, 1, -1 do
			stream:write(string.char(data[x][y][1]));
			stream:write(string.char(data[x][y][2]));
			stream:write(string.char(data[x][y][3]));
			stream:write(string.char(255));
		end
	end

	stream:close();
end