function io.peek(file, bytes)
	bytes = bytes or 1;
	if ( type(file) ~= "userdata" ) then
		error("bad argument (1) expected user data, recieved "..type(file));
	end

	local cur = file:seek();
	local data = file:read(bytes);
	file:seek("set", cur);

	return data;
end

function io.read_short(file)
	if ( type(file) ~= "userdata" ) then
		error("bad argument (1) expected user data, recieved "..type(file));
	end

	local b1 = string.byte(file:read(1));
	local b2 = string.byte(file:read(1));

	return b2 * 256 + b1;
end

function io.read_int(file)
	if ( type(file) ~= "userdata" ) then
		error("bad argument (1) expected user data, recieved "..type(file));
	end

	local b1 = string.byte(file:read(1));
	local b2 = string.byte(file:read(1));
	local b3 = string.byte(file:read(1));
	local b4 = string.byte(file:read(1));

	return b2*256+b1+b3*256^2+b4*256^3;
end

function io.read_byte(file)
	if ( type(file) ~= "userdata" ) then
		error("bad argument (1) expected user data, recieved "..type(file));
	end

	return string.byte(file:read(1));
end

function io.write_short(file, num)
	if ( type(file) ~= "userdata" ) then
		error("bad argument (1) expected user data, recieved "..type(file));
	end

	local b1 = num%256;
	local b2 = (num-b1)/256;

	if ( b1 > 255 or b2 > 255 ) then
		file:write(string.char(255)..string.char(255));
	else
		file:write(string.char(b1)..string.char(b2));
	end
end

function io.write_int(file, num)
	if ( type(file) ~= "userdata" ) then
		error("bad argument (1) expected user data, recieved "..type(file));
	end
	local b1 = num%256;
	local b2 = (num-b1)/256;
	local b3 = b2%256;
	local b4 = (b2-b3)/256;
	local b5 = b4%256;
	local b6 = (b4-b5)/256;

	if ( b1 > 255 or b3 > 255 or b5 > 255 or b6 > 255 ) then
		file:write(string.rep(string.char(255), 4));
	else
		file:write(string.char(b1)..string.char(b3)..string.char(b5)..string.char(b6));
	end
end

function io.read_line(file)
	if ( type(file) ~= "userdata" ) then
		error("bad argument (1) expected user data, recieved "..type(file));
	end

	local read = "";
	local line = "";
	while ( read ~= "\n" ) do
		line = line..read;
		read = file:read(1);
	end

	return line;
end
