darkbyte = darkbyte or {}
darkbyte.mm = {}

dofile("sys/lua/Minimap/includes/bitmap.lua")
function darkbyte.mm.CreateMinimapImage()
	local xsize, ysize = map("xsize"), map("ysize")
	local data = {} -- data for the bitmap file
	for y = 0, ysize do
		for x = 0, xsize do
			if ( data[xsize-x+1] == nil ) then
				data[xsize-x+1] = {}
			end
			if ( data[xsize-x+1][y+1] == nil ) then
				data[xsize-x+1][y+1] = {}
			end

			data[xsize-x+1][y+1] = {}

			local col = {0,0,0}
			if ( tile(x, y, "walkable") ) then
				col = {1,1,1}
				local p = tile(x, y, "property")
				--[[if ( p == 10 ) then
					col = {0, 45, 115}
				end

				if ( p == 11 ) then
					col = {200, 175, 175}
				end

				if ( p == 12 ) then
					col = {60, 60, 60}
				end]]--

				if ( p == 14 ) then
					col = {255,100,10}
				end
			elseif ( tile(x, y, "obstacle") ) then
				col = {120, 120, 120}
			elseif ( tile(x, y, "wall") ) then
				col = {255, 255, 255}
			elseif ( tile(x, y, "deadly") ) then
				--col = {0, 0, 255};
			end

			data[xsize-x+1][y+1] = col;
		end
	end
	io.save_bitmap("sys/lua/Minimap/minimap.bmp", data);
end

darkbyte.mm.CreateMinimapImage();
darkbyte.mm.mm_img = {32}
darkbyte.mm.isOpen = {32}
darkbyte.mm.transition = {32}
darkbyte.mm.plots = {32}
darkbyte.mm.mousepos = {32}
for i = 1, 32 do
	darkbyte.mm.isOpen[i] = false
	darkbyte.mm.transition[i] = 0.0
	darkbyte.mm.mm_img[i] = image("sys/lua/Minimap/minimap.bmp", 0, 0, 3, i);
	imagealpha(darkbyte.mm.mm_img[i], 0)
	darkbyte.mm.plots[i] = {}
	darkbyte.mm.mousepos[i] = {x = -1, y = -1}
	for j = 1, 32 do
		darkbyte.mm.plots[i][j] = image("gfx/plot.bmp", 0, 0, 3, i);
		imagealpha(darkbyte.mm.plots[i][j], 0)
	end
end

addhook("say", "darkbyte.mm.say")
addhook("startround", "darkbyte.mm.startround")
--addhook("endround", "darkbyte.mm.endround")
addhook("always", "darkbyte.mm.always")
addhook("clientdata", "darkbyte.mm.cd")
addhook("attack", "darkbyte.mm.attack")
addhook("die", "darkbyte.mm.die")

darkbyte.mm.clock = os.clock()
darkbyte.mm.color = {{255, 0, 0}, {0, 0, 255}}

function darkbyte.mm.say(id, t)
	t = t:lower()
	if ( t == "minimap" ) then
		darkbyte.mm.isOpen[id] = not darkbyte.mm.isOpen[id]
		return 1
	end
end

function darkbyte.mm.die(id)
	darkbyte.mm.isOpen[id] = false
	darkbyte.mm.transition[id] = 0
	imagealpha(darkbyte.mm.mm_img[id], 0)
	for i = 1, 32 do
		imagealpha(darkbyte.mm.plots[id][i], 0)
	end
end

function darkbyte.mm.startround()
	for i = 1, 32 do
		darkbyte.mm.isOpen[i] = false
		darkbyte.mm.transition[i] = 0.0
		darkbyte.mm.mm_img[i] = image("sys/lua/Minimap/minimap.bmp", 0, 0, 3, i);
		imagealpha(darkbyte.mm.mm_img[i], 0)
		for j = 1, 32 do
			darkbyte.mm.plots[i][j] = image("gfx/plot.bmp", 0, 0, 3, i);
			imagealpha(darkbyte.mm.plots[i][j], 0)
		end
	end
end

function darkbyte.mm.cd(id, m, x, y)
	if ( m == 0 ) then
		darkbyte.mm.mousepos[id].x = x
		darkbyte.mm.mousepos[id].y = y
	end
end

function darkbyte.mm.attack(id)
	local function dist(x, y)
					return math.sqrt((55-x)^2 + (55-y)^2)
			end
	
	if ( dist(darkbyte.mm.mousepos[id].x, darkbyte.mm.mousepos[id].y) < 50 ) then
		darkbyte.mm.isOpen[id] = not darkbyte.mm.isOpen[id]
	end
end

function darkbyte.mm.endround()
		for i = 1, 32 do
		darkbyte.mm.isOpen[i] = false
		darkbyte.mm.transition[i] = 0.0
		freeimage(darkbyte.mm.mm_img[i])
		darkbyte.mm.mm_img[i] = image("sys/lua/Minimap/minimap.bmp", 0, 0, 3, i);
		imagealpha(darkbyte.mm.mm_img[i], 0)
		for j = 1, 32 do
			freeimage(darkbyte.mm.plots[i][j])
			darkbyte.mm.plots[i][j] = image("gfx/plot.bmp", 0, 0, 3, i);
			imagealpha(darkbyte.mm.plots[i][j], 0)
		end
	end
end

function darkbyte.mm.always()
	reqcld(0, 0)
	local function GetElapsedTime() return os.clock() - darkbyte.mm.clock end
	local t = player(0, "tableliving")
	
	for _, v in pairs(t) do
		if ( not player(v, "bot") ) then
			if ( darkbyte.mm.isOpen[v] ) then
				darkbyte.mm.transition[v] = darkbyte.mm.transition[v] + GetElapsedTime() * 3
			else
				darkbyte.mm.transition[v] = darkbyte.mm.transition[v] - GetElapsedTime() * 3
			end

			if ( darkbyte.mm.transition[v] < 0 ) then
				darkbyte.mm.transition[v] = 0
			end
			
			if ( darkbyte.mm.transition[v] > 1 ) then
				darkbyte.mm.transition[v] = 1
			end
			
			for i = 1, 32 do
				imagealpha(darkbyte.mm.plots[v][i], 0)
			end
			
			local mapx, mapy = map("xsize"), map("ysize")
			local vtm = player(v, "team")
			for _, i in pairs(t) do
				local tm = player(i, "team")
				imagecolor(darkbyte.mm.plots[v][i], 0, 255, 0)
				if ( v ~= i ) then
					imagecolor(darkbyte.mm.plots[v][i], darkbyte.mm.color[tm][1],darkbyte.mm.color[tm][2],darkbyte.mm.color[tm][3])
				end
				
				imagescale(darkbyte.mm.plots[v][i], darkbyte.mm.transition[v]*4, darkbyte.mm.transition[v]*4)
				imagealpha(darkbyte.mm.plots[v][i], darkbyte.mm.transition[v] < 0.85 and darkbyte.mm.transition[v] or 0.85)
				local x = player(v, "x")-320+320*darkbyte.mm.transition[v] + (player(i, "tilex")*4)-(mapx*4)/2
				local y = player(v, "y")-240+240*darkbyte.mm.transition[v] + (player(i, "tiley")*4)-(mapy*4)/2
				
				imagepos(darkbyte.mm.plots[v][i], x, y, 0)
				
				if ( tm ~= vtm or vtm == 0 ) then
					imagealpha(darkbyte.mm.plots[v][i], 0)
				end
			end
			
			imagealpha(darkbyte.mm.mm_img[v], darkbyte.mm.transition[v] < 0.85 and darkbyte.mm.transition[v] or 0.85)
			imagescale(darkbyte.mm.mm_img[v], darkbyte.mm.transition[v]*4, darkbyte.mm.transition[v]*4)
			imagepos(darkbyte.mm.mm_img[v], player(v, "x")-320+320*darkbyte.mm.transition[v], player(v, "y")-240+240*darkbyte.mm.transition[v], 0)
		else
			darkbyte.mm.isOpen[v] = false
		end
		darkbyte.mm.clock = os.clock()
	end
end